<?
/*
  Looty - a Guild Bank Interface
  ==============================
*/

// set the error reporting level to avoid silly notices about unset variables etc.
error_reporting(E_ALL ^ E_NOTICE);

// few basic settings about this verison of Looty
$lootycredits	= 'By Fin :: fin@instinct.org :: http://fin.instinct.org/ :: Stormrage EU';
$lootyexample	= 'http://www.azerothselite.net/roster/looty/';
$lootyver	= '1.1';
$lootydate	= '2007-01-11';

// import request vars for servers without register_globals set to On
import_request_variables('GPC');

// get the config
include './config.php';	

// check if we can use roster's db config
/*
if ($rosterconf && is_readable($rosterconf)) {
	$olderrlvl = error_reporting(0);

	ob_start();
	include $rosterconf;
	ob_end_flush();

	error_reporting($olderrlvl);

	$dbuser = $db_user;
	$dbpass = $db_passwd;
	$dbhost = $db_host;
	$dbname = $db_name;
	}
*/

// connect to the db
include 'bits/dbsetup.inc';

// init some vars
$tdclasses = array(
	'item',
	'itemlight',
	);

$itemclasses = array(
	'#ffffff' => 'common',
	'#1eff00' => 'uncommon',
	'#0070dd' => 'superior',
	'#a335ee' => 'epic',
	);

$itemclassindex = array_flip($itemclasses);

if ($itemclass)
	$itemclass = $itemclassindex[$itemclass];

$money = array(
	'gold'		=> 0,
	'silver'	=> 0,
	'copper'	=> 0,
	);

if (!isset($expand) && $longdisplay)
	$expand	= true;

$guildname		= htmlspecialchars($guildname);
$guildname_plain	= $guildname;
$guildmaster		= htmlspecialchars($guildmaster);
$guildserver		= htmlspecialchars($guildmaster);

if ($guildurl)
	$guildname = "<a href='$guildurl'>$guildname</a>";

if (!empty($bankchars)) {
	foreach ($bankchars as $tmpchar => $tmpdesc) {
		if (!$bankchars[$tmpchar]) {
			unset($bankchars[$tmpchar]);
			}
		}
	}

if ($bankchar && empty($bankchars)) {
	$bankchars = array(
		$bankchar	=> 'Guild Bank',
		);
	}

if (!$bankchars) {
	$bankchars = array();
	die('No bank characters found - configure this setting in config.php');
	}

$allchars = $bankchars;

// reset $char if using different case
foreach ($bankchars as $tmpchar => $tmpdesc) {
	if (strtoupper($char) == strtoupper($tmpchar)) {
		$char = $tmpchar;
		}
	}

if ($char && $bankchars[$char]) {
	$tmpchar = $bankchars[$char];

	$bankchars = array(
		$char => $tmpchar,
		);
	}

$numlootchars = count($allchars);

// get details of bank characters from the db
foreach ($bankchars as $tmpchar => $tmpdesc) {
	$quotedchars[]	= "'" . addslashes(strtoupper($tmpchar)) . "'";
	}

$sql	= "select * from {$dbprefix}players"
	. ' where upper(name) in (' . join(', ', $quotedchars) . ')';

$result	= mysql_query($sql); echo mysql_error();


// make sure we have some character data
if (!mysql_num_rows($result)) {
	die('Failed to get any player data from the database - check settings in config.php and whether CharacterProfiler is importing data correctly');
	}


// make a list of member ids, names, and money
while ($player = mysql_fetch_array($result, MYSQL_ASSOC)) {
	$memberids[$player['name']]		= $player['member_id'];
	$membernames[$player['member_id']]	= $player['name'];

	$membermoney[$player['name']]['copper']	+= $player['money_c'];
	$membermoney[$player['name']]['silver']	+= $player['money_s'];
	$membermoney[$player['name']]['gold']	+= $player['money_g'];
	}

foreach ($membernames as $tmpmemberid => $tmpmembername) {
	foreach ($bankchars as $tmpbankcharname => $tmpbankchardesc) {
		if (strtoupper($tmpmembername) == strtoupper($tmpbankcharname) && ($tmpmembername != $tmpbankcharname)) {
			$bankchars[$tmpmembername] = $tmpbankchardesc;

			unset($bankchars[$tmpbankcharname]);
			}
		}
	}

// init the $wheres for the item select query
$wheres = array(
	"item_parent != 'bags'",
	'member_id in (' . join(', ', $memberids) . ')',
	);

if ($hidequest)
	$wheres[] = "item_parent != 'equip'";

if ($hidesoulbound)
	$wheres[] = "item_tooltip not like '%Soulbound%'";

if ($hideequipped)
	$wheres[] = "item_tooltip not like '%Quest Item%'";

if ($itemclass) {
	$tmpcolor = preg_replace('/^#/', '', $itemclass);
	$wheres[] = "(item_color = '$tmpcolor' or item_color = 'ff$tmpcolor')";
	}

if ($filter) {
	$wheres[]	= $searchtips
			? "(item_name like '%$filter%' or item_tooltip like '%$filter%')"
			: "item_name like '%$filter%'";
	}

if (!isset($char))
	$char	= '';

if (isset($char)) {
	// set the default guild
	if (!$char)
		$guild	= '';

	// multi-guild stuff here a bit messy
	if ($guild && !empty($guildchars[$guild]))
		$bankcharnames = $guildchars[$guild];
	else
	// serves me right for starting something and dropping it halfway through
		$bankcharnames = array_keys($bankchars);

	foreach ($bankcharnames as $charname) {
		if ($memberids[$charname]) {
			$tmpmemberids[] = $memberids[$charname];

			$money['copper']	+= $membermoney[$charname]['copper'];
			$money['silver']	+= $membermoney[$charname]['silver'];
			$money['gold']		+= $membermoney[$charname]['gold'];
			}
		}


	$count	= 0;

	$sql	= "select * from {$dbprefix}items"
		. ($wheres ? ' where ' . join(' and ', $wheres) : '')
		. ($sort ? '' : ' order by item_name')
		;

	$result	= mysql_query($sql); echo mysql_error();

	while ($item = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$index	= ++$count;

		$item['tooltip_orig']	= $item['item_tooltip'];

		if (preg_match('/Requires Level (\d+)/', $item['tooltip_orig'], $m))
			$item['level'] = $m[1];

		if ($minlevel && ($item['level'] < $minlevel))
			continue;

		if ($maxlevel && ($item['level'] > $maxlevel))
			continue;

		$item['index']		= $index;
		$item['name']		= $item['item_name'];
		$item['color']		= preg_replace((strlen($item['item_color']) == 8 ? '/^ff/' : '/^/'), '#', $item['item_color']);
		$item['class']		= $itemclasses[$item['color']];
		$item['amount']		= $item['item_quantity'];
		$item['player']		= $membernames[$item['member_id']];
		$item['icon']		= preg_replace('%\\\%', '/', $item['item_texture']);
		$item['htmlname']	= preg_replace('/ /', '&nbsp;', $item['name']);

		$item['tooltip']	= htmlspecialchars(stripslashes(trim($item['item_tooltip'])));
		$item['tooltip']	= preg_replace('/\s\n/', '&nbsp;', $item['tooltip']);
		$item['tooltip']	= trim(preg_replace("%(.+)\n%", "<span style='font-weight: bold; color: {$item['color']};'>{$item['htmlname']}</span>\n\n", $item['tooltip'], 1));

		$item['tooltip']	= preg_replace('/\|cf(......).([^|]+?)\|r/', "\n<span style='color: $1;'>$2</span>\n", $item['tooltip']);
		$item['tooltip']	= preg_replace('/Requires(.*)/', "\n<span style='color: red;'>Requires</span><span style='color: orange;'>\\1</span>", $item['tooltip']);
		$item['tooltip']	= preg_replace('/(Equip|Use)(.*)/', "\n<span style='color: #1EFF00;'>$1$2</span>", $item['tooltip']);
		$item['tooltip']	= preg_replace('/\n{2,}/', "\n\n", $item['tooltip']);

		$item['info']		= preg_split('/\n/', $item['tooltip'], -1, PREG_SPLIT_NO_EMPTY & PREG_SPLIT_DELIM_CAPTURE);

		array_shift($item['info']);
		array_shift($item['info']);

		$item['tooltip']	= nl2br($item['tooltip']);
		$item['tooltip_len']	= strlen($item['tooltip']);

		if ($iconurlbase) {
			$iconurlbase	= preg_replace('%/+$%', '', $iconurlbase);
			$item['icon']	= "$iconurlbase/{$item['icon']}";
			}

		if (($existing = $itemnames[$item['name']]) && ($items[$existing]['player'] == $item['player'])) {
			$items[$existing]['amount'] += $item['amount'];
			}
		else {
			$itemnames[$item['name']] = $index;
			$items[$index] = $item;
			}
		}

	$total = count($items);

	if ($money['copper'] > 100) {
		$extrasilver		= floor($money['copper'] / 100);
		$money['silver']	+= $extrasilver;
		$money['copper']	-= 100 * $extrasilver;
		}

	if ($money['silver'] > 100) {
		$extragold		= floor($money['silver'] / 100);
		$money['gold']		+= $extragold;
		$money['silver']	-= 100 * $extragold;
		}
	}

function pre($var) { echo '<pre>'; print_r($var); echo '</pre>'; }

function init_sort($items, $field, $reverse) {
	uksort($items, create_function('$a, $b', 'if ($a == $b) return 0; return strcmp($a[\'' . $field . '\'], $b[\'' . $field . '\']);'));
	
	return $reverse ? array_reverse($items, true) : $items;
	}

function sort_items($unsorted=array(), $sort='', $desc=false) {
	global $itemclasses;

	if (empty($unsorted))
		return array();

	$count = 0;

	foreach ($unsorted as $index => $item) {
		$sorted[$item['player']][++$count] = $item;
		}

	if ($sort) {
		// sort by given field
		foreach ($sorted as $char => $items) {
			$sorted[$char] = init_sort($items, $sort, $desc);
			}
		}
	else {
		// sort by class
		foreach ($sorted as $char => $items) {
			foreach ($items as $index => $item) {
				$tmpitems[$char][$item['class']][++$count] = $item;
				}
			}

		foreach ($tmpitems as $char => $itemsbyclass) {
			foreach ($itemclasses as $tmpclass) {
				if (empty($tmpitems[$char][$tmpclass]))
					continue;

				foreach ($tmpitems[$char][$tmpclass] as $newitem) {
					$tmpsorted[$char][++$count] = $newitem;
					}
				}
			}

		$sorted = $tmpsorted;
		}

	return $sorted;
	}

$oldsort = $sort;

if (!$desc && ($sort == $oldsort))
	$oldsort .= "&desc=1";

$items = sort_items($items, $sort, $desc);
?>
<html>

<head>

<title>
Guild Bank for <?=$guildname_plain?>
</title>

<link rel="stylesheet" type="text/css" href="bits/bank.css" />

<meta name="Abstract" content="<?=$guildname_plain?> Guild Bank">
<meta name="Description" content="List of items currently held in the guild bank for <?=$guildname_plain?> of the <?=$guildserver?> realm.">

<meta http-equiv="Content-Type" content="text/html; charset=utf-8">

<meta name="Author" content="<?=htmlspecialchars($lootycredits)?>">
<meta name="X-Looty-Version" content="<?=$lootydate?> v<?=$lootyver?>">

<? if ($showtooltips) { ?>
<script type="text/javascript">
<?	include 'bits/tooltips.js'; ?>
</script>
<?	} ?>

</head>

<body>

<p><table width=600 cellpadding=4 cellspacing=0 class=loot>

<tr><td class=loothead align=center style="font-size: 18px;">
<?=$guildname_plain?> Guild Bank
</td></tr>

<tr><td>
Below is listed the contents of the guild bank for <b><?=$guildname?></b>.
</td></tr>

<tr><td>
Please contact <b><?=$guildmaster?></b> with any questions.
</td></tr>

</table>

<form action="<?=$_SERVER['PHP_SELF']?>" name=looty>

<input type=hidden name=char value="<?=$char?>">
<input type=hidden name=expand value="<?=$expand?>">

<p><table class=loot cellpadding=4 cellspacing=0>

<tr><td colspan=2 class=loothead>
Search for an item<?=($numlootchars > 1 ? ' or list by category:' : '')?>
</td></tr>

<tr><td class=item colspan=2>
	<table cellpadding=2 cellspacing=0 width="100%">

	<tr>
	<td width="40%">

<? if ($numlootchars > 1) { ?>

	<select style="width: 100%;" name=charchooser onchange="document.location='<?=$_SERVER['PHP_SELF']?>?minlevel=<?=$minlevel?>&maxlevel=<?=$maxlevel?>&expand=<?=$expand?>&itemclass=<?=htmlspecialchars($itemclasses[$itemclass])?>&filter=' + looty.filter.value + '&char=' + this.options[this.selectedIndex].value;">
	<option value="">list all items in the bank</option>
	<? foreach ($allchars as $tmpchar => $tmpdesc) { ?>
	<option value="<?=htmlspecialchars($tmpchar)?>"<?=($tmpchar == $char ? ' selected' : '')?>><?=$tmpdesc?></option>
	<?	} ?>
	</select>

<?	} ?>
	</td>

	<td width="40%">
	<select style="width: 100%;" name=itemclass onchange="document.location='<?=$_SERVER['PHP_SELF']?>?minlevel=<?=$minlevel?>&maxlevel=<?=$maxlevel?>&expand=<?=$expand?>&char=<?=htmlspecialchars($char)?>&filter=' + looty.filter.value + '&itemclass=' + this.options[this.selectedIndex].value;">
	<option value="">any quality</option>
	<? foreach ($itemclasses as $tmpclass) { ?>
	<option value="<?=htmlspecialchars($tmpclass)?>"<?=($itemclassindex[$tmpclass] == $itemclass ? ' selected' : '')?>><?=$tmpclass?></option>
	<?	} ?>
	</select>
	</td>

	<td>min&nbsp;level:</td>
	<td><input type=text name=minlevel value="<?=$minlevel?>" size=4 style="text-align: right;"></td>
	<td>max&nbsp;level:</td>
	<td><input type=text name=maxlevel value="<?=$maxlevel?>" size=4 style="text-align: right;"></td>

	</tr>

	</table>
</td></tr>

<tr>
<td class=item><input type=text name=filter style="height: 20px; width: 550px;" value="<?=htmlspecialchars(stripslashes($filter))?>"></td>
<td class=item><input type=submit value="go" style="width: 30px; height: 20px; background-color: #DAA520;"></td>
</tr>

</table>

</form>

<? if (!$total) { ?>

<p><table cellpadding=4 cellspacing=0>

<tr><td style="color: #CCC;">
No items found for <?=$char?>
</td></tr>

<? } else { ?>

<p><table class=loot cellpadding=4 cellspacing=0 width=600>

<tr><td colspan=<?=(((!$char && $guild) ? 5 : 4) + ($showicons ? 0 : 1))?> style="border-bottom: 4px double black;">
	<table cellpadding=0 cellspacing=0 width="100%">

	<tr>
	<td style="font-weight: bold;">Matching <?=($char ? "items held by <b>$char</b>" : 'all items in the guild bank')?> (<?=$total?> item<?=($total == 1 ? '' : 's')?>) - [<a href="<?="{$_SERVER['PHP_SELF']}?minlevel=$minlevel&maxlevel=$maxlevel&sort=$sort&char=$char&itemclass={$itemclasses[$itemclass]}"?>&filter=<?=urlencode($filter)?>&expand=<?=($expand ? 0 : 'yes')?>"><?=($expand ? 'collapse' : 'expand')?></a>]</td>

	<? if ($showmoney) { ?>
	<td style="font-weight: bold;" align=right><?=($char ? "balance for $char" : 'overall balance')?>: <span style="color: gold;"><?=$money['gold']?>g</span> <span style="color: silver;"><?=$money['silver']?>s</span> <span style="color: #F4A460;"><?=$money['copper']?>c</span></td>
	<?	} ?>
	</tr>

	</table>
</td></tr>

<tr>
<? if ($showicons) { ?>
<td class=loothead align=right>&rarr;</td>
<?	} ?>
<!--
<td class=loothead><a class=loothead href="<?="{$_SERVER['PHP_SELF']}?minlevel=$minlevel&maxlevel=$maxlevel&sort=name&oldsort=$oldsort&char=$char&itemclass={$itemclasses[$itemclass]}&expand=$expand"?>&filter=<?=urlencode($filter)?>">item</a></td>
<td class=loothead align=right><a class=loothead href="<?="{$_SERVER['PHP_SELF']}?minlevel=$minlevel&maxlevel=$maxlevel&sort=amount&oldsort=$oldsort&char=$char&itemclass={$itemclasses[$itemclass]}&expand=$expand"?>&filter=<?=urlencode($filter)?>">quantity</a></td>
-->
<td class=loothead class=loothead>item name</td>
<td class=loothead class=loothead align=right>quantity</td>
<? if (!$char && $guild) { ?>
<td class=loothead><a class=loothead href="<?="{$_SERVER['PHP_SELF']}?minlevel=$minlevel&maxlevel=$maxlevel&sort=member_id&oldsort=$oldsort&char=$char&itemclass={$itemclasses[$itemclass]}&expand=$expand"?>&filter=<?=urlencode($filter)?>">owner</a></td>
<?	} ?>
<td class=loothead>&nbsp;</td>
</tr>

<?
foreach ($items as $thischar => $loot) {
	if (true || !$char) {
?>

<tr><td colspan=<?=(((!$char && $guild) ? 5 : 4) + ($showicons ? 0 : 1))?> style="border-bottom: 4px double black; font-weight: bold; text-align: center;">
<?=$thischar?>
</td></tr>

<?		} ?>

<?	foreach ($loot as $key => $item) { ?>

<tr>
<? 		if ($showicons) { ?>
<td class=<?=$tdclasses[($count % 2)]?>><span onmouseover="dispSub(sub<?=$key?>, <?=strlen($item['tooltip'])?>);" <?=($showtooltips ? "onmouseout=\"dispSub(sub$key, {$item['tooltip_len']});\"" : '')?>><img src='<?=$item['icon']?>.jpg' height=20 width=20 alt="<?=$item['name']?>"></span></td>
<?			} ?>
<td class=<?=$tdclasses[($count % 2)]?> style="white-space: nowrap;" width="100%"><span <?=($showtooltips ? "onmouseover=\"dispSub(sub$key, {$item['tooltip_len']});\" onmouseout=\"dispSub(sub$key, {$item['tooltip_len']});\"" : '')?> style="<?=($item['color'] == '#0070dd' ? 'font-weight: bold; ' : '')?>color: <?=$item['color']?>;"><?=$item['name']?></span><?=(($item['level'] && $showlevel) ? " [{$item['level']}]" : '')?><div id="sub<?=$key?>" style="border: 2px solid #BDB76B; padding: 10px; display: none; white-space: normal; position: absolute; background-color: black;"><?=$item['tooltip']?></div></td>
<td class=<?=$tdclasses[($count % 2)]?> align=right style="font-weight: bold;"><?=($item['amount'] > 1 ? "x{$item['amount']}" : '')?></td>

<?		if (!$char && $guild) { ?>

<td class=<?=$tdclasses[($count % 2)]?> style="padding-left: 10px;"><a href="<?="{$_SERVER['PHP_SELF']}?char={$item['player']}&sort=$sort"?>"><?=$item['player']?></a></td>

<?			} ?>

<td class=<?=$tdclasses[($count++ % 2)]?> style="padding-left: 10px; white-space: nowrap;">[&nbsp;<a href="http://www.thottbot.com/?i=<?=urlencode($item['name'])?>" target=_blank>thottbot</a>&nbsp;|&nbsp;<a href="http://wow.allakhazam.com/search.html?q=<?=urlencode($item['name'])?>" target=_blank>allakhazam</a>&nbsp;]</td>
</tr>

<?		if ($expand) { ?>

<tr>
<td>&nbsp;</td>
<td colspan=<?=(((!$char && $guild) ? 5 : 4) + ($showicons ? 0 : 1))?>><?=join('<br>', $item['info'])?></td>
</tr>

<?			} ?>

<?		} ?>

<?	} ?>

<? } ?>

</table>


<? for ($i = 0; $i < $k; $i++) { ?>
<div id="sub<?=($i + $total)?>" style="display: none;"></div>
<?	} ?>


<!-- tooltip space -->

<br><br><br><br><br><br><br><br><br><br><br><br>

</body>

</html>
